﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using System.Collections.Specialized;

namespace GridGroupingControl_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.gridGroupingControl1.ThemesEnabled = true;
            this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro;
            
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity.RowIndex > 2 && e.TableCellIdentity.Column!=null)
            {                
                if (defaultDatasource && e.TableCellIdentity.Column.Name=="Data1")
                {
                    e.Style.CellType = GridCellTypeName.ComboBox;
                    e.Style.ChoiceList = defaultDatasourcelist;
                }
                if(employeeDatasource && e.TableCellIdentity.Column.Name=="Data2")
                {
                    e.Style.CellType = GridCellTypeName.ComboBox;
                    e.Style.ChoiceList = employeeDatasourcelist;
                }

            }
        }
        DataTable data = new DataTable();
        DataTable employeeTable = new DataTable();
        bool defaultDatasource=false;
        bool employeeDatasource = false;
        StringCollection defaultDatasourcelist = new StringCollection();
        StringCollection employeeDatasourcelist = new StringCollection();

        
        private void Form1_Load(object sender, EventArgs e)
        {
            defaultDatasource = true;
            data.Columns.Add("Sample Test");
            data.Columns.Add("Data1");
            data.Columns.Add("Data2");
            data.Columns.Add("Data3");
            for(int i=0;i<5;i++)
            {
                Random rand=new Random();
                data.Rows.Add("Sample data" + i, rand.Next(100), rand.Next(10), rand.Next(20));
            }

            employeeTable.Columns.Add("Employee");
            employeeTable.Columns.Add("Data1");
            employeeTable.Columns.Add("Data2");
            employeeTable.Columns.Add("Data3");
            for (int i = 0; i < 5; i++)
            {
                Random rand = new Random();
                employeeTable.Rows.Add("Employee Name" + i, rand.Next(100), rand.Next(10), rand.Next(20));
            }
            this.gridGroupingControl1.DataSource = data;

            defaultDatasourcelist.Add("Default item 1");
            defaultDatasourcelist.Add("Default item 2");
            defaultDatasourcelist.Add("Default item 3");
            defaultDatasourcelist.Add("Default item 4");
            employeeDatasourcelist.Add("Employee item 1");
            employeeDatasourcelist.Add("Employee item 2");
            employeeDatasourcelist.Add("Employee item 3");
            employeeDatasourcelist.Add("Employee item 4");
            this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
        }

        private void buttonAdv1_Click(object sender, EventArgs e)
        {
            defaultDatasource = true;
            employeeDatasource = false;
            this.gridGroupingControl1.DataSource = data;
        }

        private void buttonAdv2_Click(object sender, EventArgs e)
        {
            defaultDatasource = false;
            employeeDatasource = true;
            this.gridGroupingControl1.DataSource = employeeTable;            
        }
    }
}
